#!/usr/local/bin/perl

#
###                         PRIMARY UBB SCRIPT                ##
#
# Ultimate Bulletin Board is copyright Infopop Corporation, 1998-2000.
#
#       ------------ forumdisplay.cgi -------------
#
#  This file contains the functionality for the UBB
#  individual forum page display.
#
#  Infopop Corporation offers no
#  warranties on this script.  The owner/licensee of the script is
#  solely responsible for any problems caused by installation of
#  the script or use of the script, including messages that may be
#  posted on the BB.
#
#  All copyright notices regarding the Ultimate Bulletin Board
#  must remain intact on the scripts and in the HTML
#  for the scripts.
#
# For more info on the Ultimate BB,
# see http://www.UltimateBB.com
#
###############################################################
#
#If you are running UBB on IIS,
#you may need to add the following line
#if so, just remove the "#" sign before the print line below
#print "HTTP/1.0 200 OK\n";
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \

#substitute all require files here for the file

require "UltBB.setup";
require "Date.pl";
require "mods.file";
require "ubb_library.pl";

};

print ("Content-type: text/html\n\n");

&ReadParse;

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);

	if ($Name eq "forum") {
		$Forum = $Value;
		$Forum =~ s/\/\\//g;
		$ForumCoded = &HTMLIFY($Forum);
		$ForumCoded =~ tr/ /+/;
		$Forum = &UNHTMLIFY($Forum);
	}
	if ($Name eq "TopicSubject") {
		$TopicSubject = $Value;
		$TopicSubject =~ s/<.+?>//g;
		$TopicSubject = &UNHTMLIFY($TopicSubject);
	}
	if ($Name eq "UserName") {
		$UserName = $Value;
		$UserNameFile = $UserName;
		$UserNameFile =~ s/ /_/g; #remove spaces
	}
	if ($Name eq "BypassCookie") {
		$BypassCookie = $Value;
	}
	if ($Name eq "category") {
		$category = $Value;
		$CategoryName = &GetCatName($category);
	}
	if ($Name eq "PasswordConfirm") {
		$PasswordConfirm = $Value;
	}

	if ($Name eq "number") {
		$number = $Value;
		unless($number =~ /^A:\d{6}$/i) {
		 $number =~ s/\D//sg;
		}
	}
	if ($Name eq "DaysPrune") {
		$DaysPrune = $Value;
	}
	if ($Name eq "topic") {
		$topic = $Value;
	}

	if ($Name eq "TotalPosts") {
		$TotalPosts = $Value;
	}
	if ($Name eq "sendto") {
		$sendto = $Value;
	}
}  # end FOREACH $row

if ($VariablesPath eq "") {
	$VariablesPath = $CGIPath;
}

if (-e "$ForumsPath/Forum$number/forumstyles.file") {
require "$ForumsPath/Forum$number/forumstyles.file";
$use_forum_styles++;
}  else {
require "$VariablesPath/Styles.file";
}

$infopopcopy =~ s/\"\"/\"$CopyrightTextColor\"/; # fix missing copyright text color in custom styles

my $RegLinkHere = "";
unless ($DisplayRegistration eq "NO") {
$RegLinkHere = qq(<A HREF="$CGIURL/ubbmisc.cgi?action=editbio&Browser=$Browser&DaysPrune=$DaysPrune&LastLogin=$in{'LastLogin'}"><ACRONYM TITLE="    ."></ACRONYM></A> | <A HREF="$CGIURL/Ultimate.cgi?action=agree"><ACRONYM TITLE="!"></ACRONYM></A> |);
}

if ($AllowSearch eq "FALSE") {
$SearchOption = "";
}  else {
$SearchOption = qq(| <A HREF="$CGIURL/search.cgi?action=intro&default=$number"><ACRONYM TITLE="    ,    ."></ACRONYM></A>);
}

if ($use_forum_styles) { # set above with -e

$Header = $ForumHeader unless ($ForumHeader eq '');
$Footer = $ForumFooter unless ($ForumFooter eq '');

}


if( ($Header ne "") || ($Footer ne "") ) {
	#create random numbers for headers/footers
	$RandomNumber = &MakeRandomNumber;
	$RandomNumber2 = $RandomNumber + 100074;

 if ($Header ne "") {
   $Header =~ s/UBBrandomX/$RandomNumber/isg;
   $Header =~ s/UBBrandomY/$RandomNumber2/isg;
 }
 if ($Footer ne "") {
   $Footer =~ s/UBBrandomX/$RandomNumber/isg;
   $Footer =~ s/UBBrandomY/$RandomNumber2/isg;
 }

}





#adjust bgcolor variables
if ($BGColor ne ""){
$BGColor = qq(bgcolor="$BGColor");
}
if ($AltColumnColor1 ne ""){
$AltColumnColor1 = qq(bgcolor="$AltColumnColor1");
}
if ($AltColumnColor2 ne ""){
$AltColumnColor2 = qq(bgcolor="$AltColumnColor2");
}
if ($CategoryStripColor ne ""){
$CategoryStripColor = qq(bgcolor="$CategoryStripColor");
}
if ($TableColorStrip ne ""){
$TableColorStrip = qq(bgcolor="$TableColorStrip");
}
if ($PageBackground ne ""){
$PageBackground = qq(background="$NonCGIURL/$PageBackground");
}

if ($TableBorderColor ne ""){
$TableWidth2 = "100%";
$BorderTop = qq(<table border=0 cellpadding=0 cellspacing=0 width="$TableWidth"><TR><td bgcolor="$TableBorderColor">);
$BorderBottom = qq(</td></tr></table> );
}  else {
$TableWidth2 = $TableWidth;
$BorderTop = "";
$BorderBottom = "";
}


if ($BBStatus eq "OFF") {
&StandardHTML($BBClosedMessage);
exit;
}

$ReplyMessage = $in{'ReplyMessage'};
$Message = $in{'Message'};

		$SubjectCoded = &HTMLIFY($TopicSubject);
		$SubjectCoded =~ tr/ /+/;

if (@in == 0) {
&Topics;
exit;
}
if ($in{'action'} eq "topics") {
 &Topics;
 exit;
 }
if ($in{'action'} eq "idcheck") {
#&HackChecker;
 &idcheck;
 }

if ($in{'action'} eq "displayprivate") {
 &DisplayPrivate;
 }
sub Topics {

if ($number eq "") {
&StandardHTML("   -   .     .");
exit;
}

&get_cookie;  #retrieves all current cookies
	$SessionLogin = "$cookie{sessionLogin}";
	$SessionLoginDT = "$cookie{sessionLoginDT}";

#check to see if forum is private!
if ($number =~ /A/) {
($junk, $ArchiveNumber) = split(/\:/, $number);
&DisplayArchive($ArchiveNumber);
exit;
}

@thisforum = &GetForumRecord($number);


if ($thisforum[8] eq "") {
&StandardHTML("       .     .");
exit;
}
$category = $thisforum[0];
$CategoryName = &GetCatName($category);
$ForumPW = $thisforum[12];

$LWA = $thisforum[6];

if ($LWA eq "private") {
	$ReplyRestrict = "restrict";
	$TopicRestrict = "restrict";
}  else {
($TopicRestrict, $ReplyRestrict) = split("&", $LWA);
}

$Moderator = ("Forum" . "$number" . "Moderator");
$Moderator = $$Moderator;
#split up Mod var
@mods = split(/\|\|\^\|\|/, $Moderator);


if ($LWA eq "private") {
$PrivateMax = $thisforum[13];
chomp($PrivateMax);
#check for private cookies to see if we can proceed immediately
	$PasswordPrivate = "$cookie{PasswordPrivate}";
	$UserNamePrivate = "$cookie{UserNamePrivate}";
	$NumbersPrivate = "$cookie{ForumNumberPrivate}";

$DIRPW = "$thisforum[7]";
$ExactPath = "Forum$number/private-$DIRPW";
if ($PasswordPrivate ne "") {
&VerifyID;

	if (($ForumPW ne "") && ($ProceedNow ne "true")) {
		&ConfirmIdentity;
		exit;
	}

} else {
&ConfirmIdentity;
exit;
}


}  else {
$DIRPW = "";
$ExactPath = "Forum$number";
$ProceedNow = "true";
}

if ($ProceedNow eq "true") {

if ($DaysPrune eq "") {
$DaysPrune = "$cookie{DaysPrune}";
}
if ($DaysPrune eq "") {
$DaysPrune = $DaysPruneDefault;
}

if ($in{'start'} eq "here") {
	$AddNewSessionLogin = "true";
}

$Forum = $thisforum[1];
$CustomTitle = $thisforum[9];
chomp($CustomTitle);
if ($CustomTitle eq "") {
$CustomTitle = "$BBTitle";
}
if ($TopicRestrict eq "restrict") {
	$TopicLegend = "<B> :</B>          .";
}
elsif ($TopicRestrict eq "allreg") {
	$TopicLegend = "<B> :</B>          .";
}  else {
	$TopicLegend = "<B> :</B>   ( )       .";
}

if ($ReplyRestrict eq "restrict") {
	$ReplyLegend = "<B>:</B>         .";
}
elsif ($ReplyRestrict eq "allreg") {
	$ReplyLegend = "<B>:</B>         .";
}
elsif ($ReplyRestrict eq "all") {
	$ReplyLegend = "<B>:</B>   ( )      .";
}  else {
	$ReplyLegend = "<B>:</B>       .";
}

$ForumCoded = &HTMLIFY($Forum);
$ForumCoded =~ tr/ /+/;

foreach $unomod(@mods) {
chomp($unomod);
$ModNumber = &GetUserNumber($unomod);
if ($ModNumber ne "") {
@theprofile = &OpenProfile("$ModNumber.cgi");
$ModeratorEmail = "$theprofile[2]";
if ($ModeratorLine ne "") {
$ModeratorLine .= qq(, <A HREF="mailto:$ModeratorEmail">$unomod</A>);
}  else {
$ModeratorLine = qq(<A HREF="mailto:$ModeratorEmail">$unomod</A>);
}
}

}


#are icons allowed? - ICON CONCEPT BY KOMBAT03!
if ($AllowIcons eq "TRUE") {
	$IconFieldHeader = qq(<TD>&nbsp;</TD>);
}  else {
	$IconFieldHeader = "";
}

#Check Announcements
&CheckAnnouncements("$number");

&TopicTopHTML;

&CurrentDate;

if ($DaysPrune eq "1000") {
$DPJulian = 0;
}  else {
$DPJulian = $CurrentJulian - $DaysPrune;
}

##### create new threads summary file, if necessary
unless (-e "$ForumsPath/$ExactPath/forum$number.threads") {
my $CreateThreadFile = "yes";
&ForumSummary($number);
}  # end UNLESS THREADS SUMMARY EXISTS
##########

## CC MODIFICATION -START-
if ($CreateThreadFile ne "yes") {
	open(THREADSFILE, "<$ForumsPath/$ExactPath/forum$number.threads") or die $!;
	while($_=<THREADSFILE>) {
		chomp; s/\r//g;	#this removes hard returns, Just In Case
		m/^(\d\d\d\d\d\d\d)\.(\d\d\d\d)\|\^\|/;	#$1 is now $PostDateJulian
		if($1 >= $DPJulian) {
		push(@thefinalarray, $_); }
		$TotalTopics++;
	}
	close THREADSFILE;
## CC MODIFICATION -END-

}

#open last number file
@foruminfo = &OpenFile("$ForumsPath/$ExactPath/lastnumber.file");
chomp($foruminfo[1]);
$LastNumberVerify = $foruminfo[1] + 0;

## CC MODIFICATION -START-
if ($TotalTopics != $LastNumberVerify) {

&SetThreadInfo;
	@finalarray = @blank;
	@thefinalarray = @blank;
&ForumSummary($number);	#this creates @finalarray
	@thefinalarray = @blank;
	foreach(@finalarray) {
		chomp;
		m/^(\d\d\d\d\d\d\d)\.(\d\d\d\d)\|\^\|/;	#$1 is now $PostDateJulian
		if($1 >= $DPJulian) { push(@thefinalarray, $_); }
	}
}

@finalarray = reverse(sort(@thefinalarray)); @thefinalarray = @blank;	#getting rid of the original also works
## CC MODIFICATION -END-

$x = $number;
#set Days Prune variable to 3 digits for matching--

if ($DaysPrune == 1) {
	$Days1 = "SELECTED";
}
elsif ($DaysPrune == 2) {
	$Days2 = "SELECTED";
}
elsif ($DaysPrune == 5) {
	$Days5 = "SELECTED";
}
elsif ($DaysPrune == 10) {
	$Days10 = "SELECTED";
}
elsif ($DaysPrune == 20) {
	$Days20 = "SELECTED";
}
elsif ($DaysPrune == 30) {
	$Days30 = "SELECTED";
}
elsif ($DaysPrune == 45) {
	$Days45 = "SELECTED";
}
elsif ($DaysPrune == 60) {
	$Days60 = "SELECTED";
}
elsif ($DaysPrune == 75) {
	$Days75 = "SELECTED";
}
elsif ($DaysPrune == 100) {
	$Days100 = "SELECTED";
}
elsif ($DaysPrune == 1000) {
	$Days1000 = "SELECTED";
}  else {
	$Days365 = "SELECTED";
}

&TopicMidHTML;
$Count = 0;

## CC MODIFICATION -START-
@goodarray2 = @finalarray;
## CC MODIFICATION -END-

$TotalGood2 = @goodarray2;
$TotalGood = $TotalGood2 - 1;
#check to see if we need to truncate this list
unless (($ForumDisplayMax eq "") || ($ForumDisplayMax eq "NONE")) {

$Sections = $TotalGood2 / $ForumDisplayMax;
$Sections = "$Sections";

if ($Sections =~ /\./) {
	($Whole, $junk) = split(/\./, $Sections);
	$Sections = $Whole;
}  else {
	$Sections = $Sections - 1;
}

if ($in{'startpoint'} eq "") {
	$StartPoint = 0;
	$ArrayStop = $ForumDisplayMax - 1;
	if ($TotalGood <= $ArrayStop) {
		$MoreTopicsWording = "";
		$ArrayStop = $TotalGood;
	}  else {
		for ($Section = 0;  $Section <= $Sections; $Section++) {
			$Starting = $Section * $ForumDisplayMax;

			$Block = $Section + 1;
			if ($Block == 1) {
			$MoreTopicsWording .= qq($Block );
			}  else {
			$MoreTopicsWording .= qq(<A HREF="$CGIURL/forumdisplay.cgi?action=topics&number=$number&forum=$ForumCoded&DaysPrune=$DaysPrune&startpoint=$Starting">$Block</a> );
			}
		}
	}
}  else {
	$StartPoint = $in{'startpoint'};
	$ArrayStop = $StartPoint + $ForumDisplayMax;
	$ArrayStop--;
	if ($TotalGood <= $ArrayStop) {
		$ArrayStop = $TotalGood;
	}
	for ($Section = 0;  $Section <= $Sections; $Section++) {
			$Starting = $Section * $ForumDisplayMax;

			$Block = $Section + 1;
			if ($StartPoint == $Starting) {
			$MoreTopicsWording .= qq($Block );
			}  else {
			$MoreTopicsWording .= qq(<A HREF="$CGIURL/forumdisplay.cgi?action=topics&number=$number&forum=$ForumCoded&DaysPrune=$DaysPrune&startpoint=$Starting">$Block</a> );
			}
		}
}

if ($MoreTopicsWording ne "") {
$MoreTopicsW = (": $MoreTopicsWording");
}

## CC MODIFICATION -START-
@temparray = @goodarray2[$StartPoint... $ArrayStop];
@goodarray2 = reverse(sort(@temparray)); @temparray = @blank;
## CC MODIFICATION -END-

}

foreach $goodie(@goodarray2) {
	chomp($goodie);
	@threadinfo = split(/\|\^\|/, $goodie);
	$ClosedItem = $threadinfo[6];
	chomp($ClosedItem);
	$ReplyCount=$threadinfo[3];
	#format date
	$ThisYear = substr($threadinfo[5], 0, 4);
	$ThisMonth = substr($threadinfo[5], 4, 2);
	$ThisDay = substr($threadinfo[5], 6, 2);
	$hour = substr($threadinfo[5], 8, 2);
	$min = substr($threadinfo[5], 10, 2);
	$HyphenIt = "$ThisMonth-$ThisDay-$ThisYear";

if ($DateFormat eq "US") {
	$TheDate = "$ThisMonth-$ThisDay-$ThisYear";
	$DateWording = "    --.";
	$DateSize = "2";
}
elsif ($DateFormat eq "Euro") {
	$TheDate = "$ThisDay-$ThisMonth-$ThisYear";
	$DateWording = "    --.";
	$DateSize = "2";
}
elsif ($DateFormat eq "USX") {
	$TheDate = &DateFormat("$HyphenIt", "USExpanded");

	$DateSize = "1";
} else {
	$TheDate = &DateFormat("$HyphenIt", "EuroExpanded");

		$DateSize = "1";
}

$TopicJulianDT = $threadinfo[0];

#format time option 1
	if ($TimeFormat eq "24HR")  {
		$FormatTime = "$hour:$min";
	}
	&NormalTime;

#format time option 2
	if ($TimeFormat eq "AMPM")  {
		$FormatTime = "$hour:$min $AMPM";
	}

if ($SessionLogin eq "") {
	if ($ClosedItem =~ /X/) {
		$FolderIcon = "<IMG SRC=\"$NonCGIURL/yellockfolder.gif\" BORDER=0>";
	}  else {
	if (($HotIcons eq "ON") && ($ReplyCount > $HotCount)) {
				$FolderIcon = "<IMG SRC=\"$NonCGIURL/hotclosed.gif\" BORDER=0>";
			}  else {
					$FolderIcon = "<IMG SRC=\"$NonCGIURL/closed.gif\" BORDER=0>";
			}
		}

} else {

	if ($TopicJulianDT > $SessionLogin) {
		if ($ClosedItem =~ /X/) {
			$FolderIcon = "<IMG SRC=\"$NonCGIURL/redlockfolder.gif\" BORDER=0>";
		}  else {
			if (($HotIcons eq "ON") && ($ReplyCount > $HotCount)) {
				$FolderIcon = "<IMG SRC=\"$NonCGIURL/hotclosedb.gif\" BORDER=0>";
			}  else {
					$FolderIcon = "<IMG SRC=\"$NonCGIURL/closedb.gif\" BORDER=0>";
			}
		}
	$NewThreadPosts = "yes";

	}  else {

		if ($ClosedItem =~ /X/) {
			$FolderIcon = "<IMG SRC=\"$NonCGIURL/yellockfolder.gif\" BORDER=0>";
		}  else {
			if (($HotIcons eq "ON") && ($ReplyCount > $HotCount)) {
				$FolderIcon = "<IMG SRC=\"$NonCGIURL/hotclosed.gif\" BORDER=0>";
			}  else {
			$FolderIcon = "<IMG SRC=\"$NonCGIURL/closed.gif\" BORDER=0>";
			}
		}

	$NewThreadPosts = "no";
	}
}

if ($AllowIcons eq "TRUE") {
	my $IconNumber = $threadinfo[7];
	chomp($IconNumber);
	if ($IconNumber eq "") {
		$IconNumber = "1";
	}
	unless (-e "$NonCGIPath/icons/icon$IconNumber.gif") {
	$IconNumber = "1";
	}
	$IconField = qq(<TD $AltColumnColor2><ACRONYM TITLE="      .        FAQ'."><IMG SRC="$NonCGIURL/icons/icon$IconNumber.gif" BORDER=0 WIDTH=15 HEIGHT=15  ALIGN=ABSCENTER></ACRONYM></td>);
}  else {
	$IconField = "";
}
&TopicGutsHTML;

} #end foreach goodarray

&TopicBottomHTML;
&GetForumSelectList;

if ($SessionLogin ne "") {
&TopicBottom2JShtml;
}  else {
&TopicBottom2NonJShtml;
}

} else {
$AccessWording = qq(      ...    .);
&ConfirmIdentity;
exit;
} # if proceednow = true

}  ## END TOPICS SR ####


sub CheckAnnouncements {
$ForumNumber = shift;

opendir (GETANNC, "$ForumsPath/$ExactPath/ANNC");
	@forummsgs = readdir(GETANNC);
closedir (GETANNC);

	@announcements = grep(/annc/, @forummsgs);

	#now we have all announcements in the forum
	#need to figure out which ones are live
	$NewAnnounce = "";

	for $eachannc(@announcements) {
		$Live = "";
		$Dead = "";

		($start, $end, $trash) = split("-", $eachannc);
		&DateCompare("$start", "$end");
		if ($Live eq "true") {
			$sortline = ("$StartJulian|$eachannc");
			push(@livelist, $sortline);
		}
	$StartJulian = ($StartJulian + .99);
		if ($StartJulian > $SessionLogin) {
			$NewAnnounce = "true";
		}
		if ($Dead eq "true") {
		unlink ("$ForumsPath/$ExactPath/ANNC/$eachannc");
		}
	} #end For $eachannc

	#now we have our list of announcements

	@thesortlist = sort(@livelist);	#sort list
	@sortlist = reverse(@thesortlist); #reverse it, latest first
	$ListTotal = @sortlist;

	($junk, $anncfile) = split(/\|/, $sortlist[0]);

	if ($ListTotal < 1) {
		$AnnouncementBlock = "";
	} else {
		if ($NewAnnounce eq "true") {
	open (LATEST, "$ForumsPath/$ExactPath/ANNC/$anncfile");
	@latest = <LATEST>;
	close (LATEST);
	$LatestTitle = $latest[1];
	chomp($LatestTitle);

			$AnnouncementBlock = "<IMG SRC=\"$NonCGIURL/newannounce.gif\" BORDER=0 ALT=\" \" align=middle>&nbsp;&nbsp; <A HREF=\"$CGIURL/ubbmisc.cgi?action=getannounce&ForumNumber=$number&Start=$StartJulian&End=$EndJulian&Session=$SessionLogin\">$LatestTitle</A>";

		}  else {
	open (LATEST, "$ForumsPath/$ExactPath/ANNC/$anncfile");
	@latest = <LATEST>;
	close (LATEST);
	$LatestTitle = $latest[1];
	chomp($LatestTitle);

			$AnnouncementBlock = "<IMG SRC=\"$NonCGIURL/announce.gif\" BORDER=0 ALT=\"\" ALIGN=middle>&nbsp;&nbsp;<A HREF=\"ubbmisc.cgi?action=getannounce&ForumNumber=$number&Start=$StartJulian&End=$EndJulian&Session=$SessionLogin\">$LatestTitle</a>";
		}

	}
} #end CheckAnnouncements sr

# HTML SUBROUTINES ASSOCIATED WITH THE
# FORUM PAGE DISPLAY ARE LISTED BELOW---

sub TopicTopHTML {
&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {
	$ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);
} else {
	$ExtraInfo = "";
}

&GetDateTime;

print <<TOP;
<HTML>
<HEAD><TITLE>$BBName</title>
<LINK REL="SHORTCUT ICON" href="$NonCGIURL/ubbicon.ico">
$HeaderInsert
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
var sessionLogin = escape("$SessionLogin");
var sessionLoginDT = escape("$SessionLoginDT");
var AddSessionInfo = escape("$AddNewSessionLogin");

expireDate = new Date();
if (expireDate.getYear() < 1900) {
expireDate.setYear(expireDate.getYear() + 1900 + 1);
} else {
expireDate.setYear(expireDate.getYear()+1);
}

if (AddSessionInfo == "true") {

var CookieLogin = escape("$LastLoginJulian");
var CookieLoginDT = escape("$LastLoginDT");

document.cookie = "lastLogin=" + CookieLogin + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";
  document.cookie = "LastLoginDT=" + CookieLoginDT + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";
	  document.cookie = "sessionLogin=" + sessionLogin + ";$ExtraInfo";
document.cookie = "sessionLoginDT=" + sessionLoginDT + ";$ExtraInfo";
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</head>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT SIZE="$TextSize" FACE="$FontFace">
$Header
TOP
}  ## END TOPIC TOP HTML sr

sub TopicMidHTML {
if ($CategoriesOnly eq "true") {
$FolderLine = qq(<IMG SRC="$NonCGIURL/tline.gif"  BORDER=0><IMG SRC="$NonCGIURL/open.gif"  BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true&category=$category">$CategoryName</A><BR><IMG SRC="$NonCGIURL/tline3.gif" BORDER=0><IMG SRC="$NonCGIURL/open.gif" BORDER=0>&nbsp;&nbsp;$Forum);

}  else {
$FolderLine = qq(<IMG SRC="$NonCGIURL/tline.gif"  BORDER=0><IMG SRC="$NonCGIURL/open.gif"  BORDER=0>&nbsp;&nbsp;$Forum);
}


print <<OtherMiddle;
<center>
<table border=0 width=$TableWidth>
<tr>
<td align=left valign=top>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$CustomTitle" BORDER=0></A>
<BR>
<FONT SIZE="$TextSize" FACE="$FontFace" color="$LinkColor"><B>$Forum</B>
<br><FONT size= "1" COLOR="$VisitedLinkColor">( $ModeratorLine)
<P>$AnnouncementBlock<BR>
</FONT></font>
</td>
<td valign=top nowrap><FONT SIZE="1" FACE="$FontFace">
<IMG SRC="$NonCGIURL/open.gif"  BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><ACRONYM TITLE="    .">$BBName</ACRONYM></A>
<BR>
$FolderLine
<P>
<CENTER>
<FONT SIZE="$TextSize" FACE="$FontFace">
<A HREF="$CGIURL/postings.cgi?action=newtopic&number=$number&forum=$ForumCoded&DaysPrune=$DaysPrune&LastLogin=$in{'LastLogin'}"><IMG SRC="$NonCGIURL/$BBTopic"  BORDER=0 ALT="  "></A></FONT>
<BR>
$RegLinkHere <A HREF="$CGIURL/ubbmisc.cgi?action=setprefs"><ACRONYM TITLE="     ."></ACRONYM></A> | <A HREF="$NonCGIURL/faq.html" target=_blank><ACRONYM TITLE="  ">faq</ACRONYM></A> $SearchOption
<p>
<FORM ACTION="$CGIURL/forumdisplay.cgi" METHOD="GET">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="topics">
<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$Forum">
<INPUT TYPE="HIDDEN" NAME="number" VALUE="$number">
<SELECT NAME="DaysPrune">
	<OPTION value="1" $Days1>    
	<OPTION value="2" $Days2>    2 
	<OPTION value="5" $Days5>    5 
	<OPTION value="10" $Days10>    10 
	<OPTION value="20" $Days20>    20 
	<OPTION value="30" $Days30>    30 
	<OPTION value="45" $Days45>    45 
	<OPTION value="60" $Days60>    60 
	<OPTION value="75" $Days75>    75 
	<OPTION value="100" $Days100>    100 
	<OPTION value="365" $Days365>    
	<OPTION value="1000" $Days1000>  
</SELECT>
<INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Ok">
</FORM>
</center>
</FONT>
</td></tr></table>


<table border=0 width=$TableWidth>
<TR>
<td><FONT SIZE="1" FACE="$FontFace">
$TopicLegend<BR>$ReplyLegend</font>
</td>
</tr>
</table>

$BorderTop
<table border=0 cellpadding=4 border=0 cellspacing=1 width=$TableWidth2>
<tr $TableColorStrip>
<td>&nbsp;</td>
$IconFieldHeader
<td>
<FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor"><B></B></FONT>
</td>
<td>
<FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor"><B> </B></FONT>
</td>
<td><FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor"><B></B></FONT>
</td>
<td NOWRAP><FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor"><B> </B></FONT>
</td></tr>
OtherMiddle
}  ## END Middle HTML for Topic Page

sub TopicGutsHTML {
if ($PrivateMax eq "yes") {
$ThisURL = qq($CGIURL/forumdisplay.cgi?action=displayprivate&number=$number&topic=$threadinfo[1]);
} else {
$ThisURL = qq($NonCGIURL/$ExactPath/HTML/$threadinfo[1].html);
}

# Multipage Links Hack Idea by Howard, rewritten by Mark Badolato
my $extrapages;
my $totalposts = $threadinfo[3] + 1;

unless ($HTMLDisplayMax eq 'NONE') {
	my $thesetotal = int ($totalposts / $HTMLDisplayMax);
	$thesetotal++ if ($totalposts % $HTMLDisplayMax);
	if ($thesetotal > 1) { 
		$extrapages = qq( <font face=$FontFace size=1> : <a href="$ThisURL">1</a> );
		for (2..$thesetotal) {
			$extrapages .= ($PrivateMax eq 'yes') ? 
			qq(<a href="$CGIURL/forumdisplay.cgi?action=displayprivate&number=$number&topic=$threadinfo[1]-$_">$_</a> ) : 
			qq(<a href="$NonCGIURL/$ExactPath/HTML/$threadinfo[1]-$_.html">$_</a> );
		}
		$extrapages .= '</font>';
	}
}

print <<GUTS;
<TR>
<TD $AltColumnColor1>
$FolderIcon</td>
$IconField
<TD $AltColumnColor1><FONT SIZE="$TextSize" FACE="$FontFace">
<A HREF="$ThisURL">$threadinfo[2]</A> $extrapages
</FONT>
</td>
<td $AltColumnColor2>
<FONT SIZE="$TextSize" FACE="$FontFace">$threadinfo[4]</FONT>
</td>
<td align=center $AltColumnColor1>
<FONT SIZE="$TextSize" FACE="$FontFace">$threadinfo[3]</FONT>
</td>
<td NOWRAP $AltColumnColor2>
<FONT SIZE="$DateSize" FACE="$FontFace">$TheDate <FONT SIZE="$DateSize" FACE="$FontFace" COLOR="$TimeColor">$FormatTime</FONT></FONT>
</td></tr>
GUTS
}  ## END Guts HTML for Topic Page


sub TopicBottomHTML {
print<<BOTTOM
</table>
$BorderBottom
<br>
<table border=0 width=$TableWidth>
<TR>
<TD align=right><FONT SIZE="$TextSize" FACE="$FontFace">$MoreTopicsW</font>
</td>
</tr></table><BR>
<table border=0 width=$TableWidth>
<tr><td align=left valign=top>
<FONT SIZE="1" FACE="$FontFace" COLOR="$VisitedLinkColor">    $TimeZone. $DateWording</FONT></td>
<td align=right NOWRAP>
<FONT SIZE="$TextSize" FACE="$FontFace">
<FORM ACTION="$CGIURL/forumdisplay.cgi" METHOD="GET">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="topics">
<B> : </B><SELECT NAME="number">
BOTTOM
} ## End TopicBottomNonIEhtml

sub TopicBottom2JShtml {
if ($HotIcons eq "ON") {
	$RedHot = " (<img src=\"$NonCGIURL/hotclosedb.gif\"  border=0 alt=\" \">&nbsp;&nbsp; $HotCount' ) ";
	$YellowHot = "(<img src=\"$NonCGIURL/hotclosed.gif\"  border=0 alt=\" \">&nbsp;&nbsp; $HotCount' )";
}  else {
	$RedHot = "";
	$YellowHot = "";
}

print<<TrueTopicBottom;
</SELECT><INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Ok"></FORM></TD></tr>
<tr>
<td colspan=5><FONT SIZE="1" FACE="$FontFace">
<img src="$NonCGIURL/closedb.gif" border=0 alt="  ">&nbsp;&nbsp;        $RedHot.<BR>
<img src="$NonCGIURL/closed.gif"  border=0 alt="  ">&nbsp;&nbsp;        $YellowHot.<BR>
<IMG SRC="$NonCGIURL/lock.gif" hspace=2 BORDER=0 ALT="Closed Thread">&nbsp;&nbsp;  -    .
</FONT>
<CENTER><FONT SIZE="$TextSize" FACE="$FontFace"><b><A HREF="$CGIURL/postings.cgi?action=newtopic&number=$number&forum=$ForumCoded">  </A></b></font><P>

</td>
</tr>
</table><P>

TrueTopicBottom

&PageBottomHTML;
}

sub TopicBottom2NonJShtml {

if ($HotIcons eq "ON") {
	$YellowHot = "(<img src=\"$NonCGIURL/hotclosed.gif\"  border=0 alt=\" \">&nbsp;&nbsp; $HotCount' )";
}  else {
	$YellowHot = "";
}
print<<TrueTopicBottom;
</SELECT><INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Ok"></FORM></FONT></TD></tr>
<tr>
<td colspan=5><FONT SIZE=1 FACe="$FontFace">
<img src="$NonCGIURL/closed.gif"  border=0 alt="  ">&nbsp;&nbsp;  $YellowHot.<BR>
<IMG SRC=\"$NonCGIURL/yellockfolder.gif\"  BORDER=0 ALT=\" \">&nbsp;&nbsp;  -    .
</font>
<CENTER><FONT SIZE="$TextSize" FACE="$FontFace"><b><A HREF="$CGIURL/postings.cgi?action=newtopic&number=$number&forum=$ForumCoded">  </A></b></font><P>
</td>
</tr>
</table><p>
TrueTopicBottom

&PageBottomHTML;
}


sub idcheck {
#open member file to see if user can access private forum

if (($in{'UserName'} eq "") || ($in{'Password'} eq "")) {
	&StandardHTML("     !     .");

	}  else {
#open registration file, if possible

$NameFound = "no";
$ProfileNumber = &GetUserNumber($in{'UserName'});
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

$AllowedToEnter = "";

if ($NameFound eq "yes") {

	@theprofile = &OpenProfile("$ProfileNumber.cgi");
	if ($in{'Password'} eq "$theprofile[1]") {
		$Permission = $theprofile[4];
		$Status = $theprofile[8];

	if ($Permission =~ /\&/) {
		($junk, $forumnumbers) = split(/\&/, $Permission);
		chomp($forumnumbers);

		if ($forumnumbers =~ /,/) {
		@forumnums = split(",", $forumnumbers);
		} else {
		@forumnums = "$forumnumbers";
		}
	}
	#check against forum password, if necessary
	@thisforum = &GetForumRecord($in{'forumnumber'});
	if ($thisforum[12] ne "") {
		if ($in{'ForumPassword'} eq "$thisforum[12]") {
			$PasswordCheck = "true";
		}
	}

	my $PermissionCheck = "false";
	CHECKPERM: foreach $theesone(@forumnums) {
		if ($theesone eq "$in{'forumnumber'}") {
			$PermissionCheck = "true";
			last CHECKPERM;
		}
	}

$ThisNumber = $in{'forumnumber'};
		$UserName = &decodeURL("$in{'UserName'}");
		&CheckModStatus("Forum$in{'forumnumber'}", "$UserName");

		if (($Status eq "Administrator") || ($PermissionCheck eq "true") || ($ModMatch eq "yes") || ($PasswordCheck eq "true")) {
		&GrantAccess;

		}  else {
		&StandardHTML(",       .");
		}
} else {
		&StandardHTML("    .    .");
}

} else {
		&StandardHTML("          .       .");
}

}
}  # end id check


sub ConfirmIdentity {

if ($ForumPW ne "") {
$FPWWording = qq(<TR $AltColumnColor1><TD colspan=2><FONT SIZE="$TextSize" FACE="$FontFace">    ,    ,      ,     ,    .</font></td></tr>
<TR $AltColumnColor2><TD><FONT SIZE="$TextSize" FACE="$FontFace">
 :</font></td><td><INPUT TYPE="PASSWORD" NAME="ForumPassword" VALUE="" SIZE=12 MAXLENGTH=12></td></tr>);
}  else {
$FPWWording = "";
}

print <<CONFIRM;
<HTML><HEAD>
$HeaderInsert
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
function SetCursor() {
var testUserName = getCookie("UserName");

if (testUserName != null) {
	document.THEFORM.UserName.value = getCookie("UserName");
document.THEFORM.Password.value = getCookie("Password");
	}  else {
	document.THEFORM.UserName.focus();
}
}
function getCookie(name){
var cname = name + "=";
var dc = document.cookie;
if (dc.length > 0) {
    begin = dc.indexOf(cname);
	 if (begin != -1) {
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));  }
}
return null;
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</HEAD>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0 onLoad="SetCursor()">
$Header
<br><br><center><FONT SIZE="$TextSize" FACE="$FontFace">
         &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;     
<FORM ACTION="$CGIURL/forumdisplay.cgi" NAME="THEFORM" METHOD="POST">
$BorderTop
<table cellpadding=4 cellspacing=1 border=0 width="$TableWidth2">
<tr $TableColorStrip><td colspan=2>
<FONT SIZE="$TextSize" FACE="$FontFace" color="$TableStripTextColor">
<B>$AccessWording
<P>     .     .  ,           ,          cookies,        .</b></td></tr>
<TR $AltColumnColor1><TD><FONT SIZE="$TextSize" FACE="$FontFace">
 :</font></td><td><INPUT TYPE="TEXT" NAME="UserName" VALUE="" SIZE=20 MAXLENGTH=35></td></tr>

<TR $AltColumnColor2><TD><FONT SIZE="$TextSize" FACE="$FontFace">
:</font></td><td><INPUT TYPE="PASSWORD" NAME="Password" VALUE="" SIZE=20 MAXLENGTH=35></td></tr>
$FPWWording
</table>
$BorderBottom
<P>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="idcheck">
<INPUT TYPE="HIDDEN" NAME="forumnumber" VALUE="$in{'number'}">
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE=" ">
<INPUT TYPE="RESET" NAME="Reset" VALUE=" "></CENTER>
</form>
<BR>
<br><br>
       , <a href="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"> </a>.
<P>
</font>$Footer
</body></html>
CONFIRM

}

sub GrantAccess {
&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {
	$ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);
} else {
	$ExtraInfo = "";
}

#get private forum dir
@forumarray = &GetForumRecord($in{'forumnumber'});
$PFDir = $forumarray[7];

print<<ForwardHTML;
<HTML><HEAD>
<meta http-equiv="Refresh" content="2; URL=$CGIURL/forumdisplay.cgi?action=topics&number=$in{'forumnumber'}">
$HeaderInsert
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
var CurrentPrivateNumbers = getCookie("ForumNumberPrivate");
var AddNumber = "$in{'forumnumber'}:$PFDir";
var CookieName = escape("$in{'UserName'}");
var CookiePW = escape("$in{'Password'}");
var TotalNumbers = "";
if (CurrentPrivateNumbers == null) {
TotalNumbers = AddNumber;
}  else {
TotalNumbers = CurrentPrivateNumbers + "::" + AddNumber;
}
	document.cookie = "PasswordPrivate=" + CookiePW + ";$ExtraInfo";
	document.cookie = "UserNamePrivate=" + CookieName + ";$ExtraInfo";
	document.cookie = "ForumNumberPrivate=" + TotalNumbers + ";$ExtraInfo";

function getCookie(name){
var cname = name + "=";
var dc = document.cookie;
if (dc.length > 0) {
    begin = dc.indexOf(cname);
	 if (begin != -1) {
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</HEAD>
 <BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<br><br>
<ul><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">
<B>!           .       ,   .
<P></font><FONT SIZE="1" FACE="$FontFace" COLOR="$LinkColor">
<A HREF="$CGIURL/forumdisplay.cgi?action=topics&number=$in{'forumnumber'}"> ,      (      ).</A>
</B><br><br>
</FONT>
</ul>$Footer</body></html>
ForwardHTML

} #end GrantAccess

sub DisplayPrivate {
#verify permission to view
#check for private cookies to see if we can proceed immediately
&get_cookie;  #retrieves all current cookies
	$PasswordPrivate = "$cookie{PasswordPrivate}";
	$UserNamePrivate = "$cookie{UserNamePrivate}";
	$NumbersPrivate = "$cookie{ForumNumberPrivate}";

	if ($PasswordPrivate ne "") {
	my @theforum = &GetForumRecord($number);
$DIRPW = "$theforum[7]";
	&VerifyID;
	}  else {
		&StandardHTML(",            .");
		exit;
	}

if ($ProceedNow eq "true") {

@thisforum = &GetForumRecord($in{'number'});

#open file
my @thisfile = &OpenFile("$ForumsPath/Forum$in{'number'}/private-$thisforum[7]/HTML/$in{'topic'}.cgi");

foreach $row(@thisfile) {
print "$row";
}
exit;

}  else {
&StandardHTML("       .");
exit;
}

}

sub VerifyID {

##check ID using username set as cookie
$NameFound = "no";
$ProfileNumber = &GetUserNumber($UserNamePrivate);

if ($NumbersPrivate ne "") {
	if ($NumbersPrivate =~ /\:\:/) {
	@CheckAccess = split(/\:\:/, $NumbersPrivate);
	}  else {
		@CheckAccess = $NumbersPrivate;
	}

	CHECKER: foreach $checker(@CheckAccess) {
		chomp($checker);
		($checknum, $checkdir) = split(/\:/, $checker);
		if ($checknum eq "$number") {
			if ($checkdir eq "$DIRPW") {
			$ProceedNow = "true";
			last CHECKER;
			}  else {
				&StandardHTML("   .");
				exit;
			} #if checkdir
		}# if checknum
	} #foreach
}  #if np

if ($ProceedNow ne "true") {

	if ($ProfileNumber ne "") {
		$NameFound = "yes";
		} else {
		$NameFound = "no";
	}

		@thisprofile = &OpenProfile("$ProfileNumber.cgi");
if ($PasswordPrivate eq "$thisprofile[1]") {
		$Permission = "$thisprofile[4]";
		$Status = $thisprofile[8];
		($GenPerms, $SpecificPerms) = split(/\&/, $Permission);

			$Moderator = ("Forum" . "$number" . "Moderator");
$Moderator = $$Moderator;
#split up Mod var
@mods = split(/\|\|\^\|\|/, $Moderator);

$ModMatch = "";
foreach $unomod(@mods) {
if ($unomod eq "$UserNamePrivate") {
	$ModMatch = "true";
}
}
		if (($Status eq "Administrator") || ($ModMatch eq "true")) {
	  		$ProceedNow = "true";
	   }
		if (($SpecificPerms ne "") && ($ProceedNow ne "true")){
			chomp($specificPerms);
			@accessarray = split(",", $SpecificPerms);
			CHECKARRAY: foreach $uno(@accessarray) {
				if ($uno eq "$number") {
					$ProceedNow = "true";
					last CHECKARRAY;
				}
			}
		}
	}
}

} #end VerifyID


sub DisplayArchive {
my $ThisArchive = shift;

if (-e "$NonCGIPath/Archives/archives.pl") {
@archives = &OpenFile("$NonCGIPath/Archives/archives.pl");
foreach $uno(@archives) {
	if ($uno =~ /^$ThisArchive/) {
		($ArchiveNum, $ArchiveName, $ArchiveDescription) = split(/\|\#\|/, $uno);
$ArchiveDescription =~ s/&quot;/"/isg;
$ArchiveDescription =~ s/&#0124;/\|/isg;
	}
}

if ($ArchiveName eq "") {
	&StandardHTML("     .      .       .");
	exit;
}
} else {
	&StandardHTML("    .");
	exit;
}

if (-e "$NonCGIPath/Archives/Archive-$ArchiveNum/archives.thread") {
@thisarchive2 = &OpenFile("$NonCGIPath/Archives/Archive-$ArchiveNum/archives.thread");
} else {
@thisarchive2 = @blank;
}

@goodarray2 = sort {lc($a) cmp lc($b) } @thisarchive2;


$TotalGood2 = @goodarray2;
$TotalGood = $TotalGood2 - 1 ;

my $ADMax = 50;
$Sections = $TotalGood2 / $ADMax;
$Sections = "$Sections";

if ($Sections =~ /\./) {
	($Whole, $junk) = split(/\./, $Sections);
	$Sections = $Whole;
}  else {
	$Sections = $Sections - 1;
}

if ($in{'startpoint'} eq "") {
	$StartPoint = 0;
	$ArrayStop = $ADMax - 1;
	if ($TotalGood <= $ArrayStop) {
		$MoreTopicsWording = "";
		$ArrayStop = $TotalGood;
	}  else {
		for ($Section = 0;  $Section <= $Sections; $Section++) {
			$Starting = $Section * $ADMax;

			$Block = $Section + 1;
			if ($Block == 1) {
			$MoreTopicsWording .= qq($Block );
			}  else {
			$MoreTopicsWording .= qq(<A HREF="$CGIURL/forumdisplay.cgi?action=topics&number=A:$ThisArchive&startpoint=$Starting">$Block</a> );
			}
		}
	}
}  else {
	$StartPoint = $in{'startpoint'};
	$ArrayStop = $StartPoint + $ADMax;
	$ArrayStop--;
	if ($TotalGood <= $ArrayStop) {
		$ArrayStop = $TotalGood;
	}
	for ($Section = 0;  $Section <= $Sections; $Section++) {
			$Starting = $Section * $ADMax;

			$Block = $Section + 1;
			if ($StartPoint == $Starting) {
			$MoreTopicsWording .= qq($Block );
			}  else {
			$MoreTopicsWording .= qq(<A HREF="$CGIURL/forumdisplay.cgi?action=topics&number=A:$ThisArchive&startpoint=$Starting">$Block</a> );
			}
		}
}

if ($MoreTopicsWording ne "") {
$MoreTopicsW = ("Page: $MoreTopicsWording");
}

@goodarray3 = @goodarray2[$StartPoint... $ArrayStop];

print<<TOP;
<HTML>
<HEAD><TITLE>$BBName</title>
$HeaderInsert
</head>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT SIZE="$TextSize" FACE="$FontFace">
$Header
<P>
<center>
<table border=0 width=$TableWidth>
<tr>
<td align=left valign=top>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A>
<P>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>$ArchiveName</b></font><BR>
<FONT SIZE="1" FACE="$FontFace">$ArchiveDescription</font>
</td>
<td valign=top nowrap><FONT SIZE="1" FACE="$FontFace">
<IMG SRC="$NonCGIURL/open.gif"  BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><ACRONYM TITLE="    .">$BBName</ACRONYM></A>
<BR>
<IMG SRC="$NonCGIURL/tline.gif"  BORDER=0><IMG SRC="$NonCGIURL/open.gif"  BORDER=0>&nbsp;&nbsp;$ArchiveName<BR>
<P>
<CENTER>
$RegLinkHere <A HREF="$CGIURL/ubbmisc.cgi?action=setprefs"><ACRONYM TITLE="     ."></ACRONYM></A> | <A HREF="$NonCGIURL/faq.html" target=_blank><ACRONYM TITLE="  ">faq</ACRONYM></A> $SearchOption</font></td></tr></table><p>
<center>
<table border=0 width=$TableWidth>
<tr $BGColor>
<TD valign=bottom><FONT SIZE="1" FACE="$FontFace">     .</font></td></tr></table>
$BorderTop
<table border=0 cellpadding=4 border=0 cellspacing=1 width=$TableWidth2>
<tr $TableColorStrip>
<TD><FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor"><B> </B></font></td><TD><FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor"><B> </B></font></td><TD><FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor"><B> </B></font></td></tr>
TOP

$AltColor = "$AltColumnColor1";

if (@goodarray3) {
foreach $one(@goodarray3) {
@thisone = split(/\|\#\|/, $one);
chomp($thisone[3]);
($theDate, $junk, $junk2) = split(/-/, $thisone[1]);

my $ThisYear = substr($theDate, 0, 4);
my $ThisMonth = substr($theDate, 4, 2);
my $ThisDay = substr($theDate, 6, 2);
my $StoredDate = "$ThisMonth-$ThisDay-$ThisYear";

if ($DateFormat eq "US") {
	$FormatDate = $StoredDate;
	$DateSize = "$TextSize";
}
elsif ($DateFormat eq "Euro") {
	$FormatDate = &DateFormat("$StoredDate", "Euro");
$DateSize = "$TextSize";
}
elsif ($DateFormat eq "USX") {
	$FormatDate = &DateFormat("$StoredDate", "USExpanded");
$DateSize = "1";
} else {
	$FormatDate = &DateFormat("$StoredDate", "EuroExpanded");
$DateSize = "1";
}

print<<GUTS;
<tr $AltColor>
<TD><FONT SIZE="$TextSize" FACE="$FontFace"><A HREF="$NonCGIURL/Archives/Archive-$ArchiveNumber/HTML/$thisone[1].html">$thisone[0]</A></font></td><TD><FONT SIZE="$TextSize" FACE="$FontFace">$thisone[2]</font></td><TD><FONT SIZE="$DateSize" FACE="$FontFace">$FormatDate</font></td></tr>
GUTS

if ($AltColor eq "$AltColumnColor1") {
	$AltColor = "$AltColumnColor2";
}  else {
	$AltColor = "$AltColumnColor1";
}
}
} else {
print<<GUTS;
<tr $AltColor>
<TD colspan=3><FONT SIZE="$TextSize" FACE="$FontFace">     !<BR><BR></font></td></tr>
GUTS
}
print<<NEXT;
</table>
$BorderBottom
<TABLE BORDER=0 WIDTH=$TableWidth>
<TR><TD>
<FONT SIZE="1" FACE="$FontFace">
 .      .    - ,    .
<P>
$MoreTopicsW</font>
<P>
<FONT SIZE="$TextSize" FACE="$FontFace">
<FORM ACTION="$CGIURL/forumdisplay.cgi" METHOD="GET">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="topics">
<B> : </B><SELECT NAME="number">
NEXT

&GetForumSelectList;

print<<NearBottom;
</SELECT>&nbsp;&nbsp;<INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Ok">
</FORM></font></TD></tr></table>
<P>
NearBottom

&PageBottomHTML;

}

exit(0); # comply with SafePerl
